<?php

namespace Asadi\Result\Http\Controllers;

use App\Http\Controllers\PublicController as BaseController;
use Asadi\Result\Interfaces\ResultRepositoryInterface;

class ResultPublicController extends BaseController
{
    // use ResultWorkflow;

    /**
     * Constructor.
     *
     * @param type \Asadi\Result\Interfaces\ResultRepositoryInterface $result
     *
     * @return type
     */
    public function __construct(ResultRepositoryInterface $result)
    {
        $this->repository = $result;
        parent::__construct();
    }

    /**
     * Show result's list.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function index()
    {
        $results = $this->repository
        ->pushCriteria(app('Litepie\Repository\Criteria\RequestCriteria'))
        ->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();

        return $this->theme->of('result::public.result.index', compact('results'))->render();
    }

    /**
     * Show result.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function show($slug)
    {
        $result = $this->repository->scopeQuery(function($query) use ($slug) {
            return $query->orderBy('id','DESC')
                         ->where('slug', $slug);
        })->first(['*']);

        return $this->theme->of('result::public.result.show', compact('result'))->render();
    }

}
