<?php

namespace Asadi\Result\Workflow;

use Asadi\Result\Models\Result;
use Asadi\Result\Notifications\Result as ResultNotifyer;
use Notification;

class ResultNotification
{

    /**
     * Send the notification to the users after complete.
     *
     * @param Result $result
     *
     * @return void
     */
    public function complete(Result $result)
    {
        return Notification::send($result->user, new ResultNotifyer($result, 'complete'));;
    }

    /**
     * Send the notification to the users after verify.
     *
     * @param Result $result
     *
     * @return void
     */
    public function verify(Result $result)
    {
        return Notification::send($result->user, new ResultNotifyer($result, 'verify'));;
    }

    /**
     * Send the notification to the users after approve.
     *
     * @param Result $result
     *
     * @return void
     */
    public function approve(Result $result)
    {
        return Notification::send($result->user, new ResultNotifyer($result, 'approve'));;

    }

    /**
     * Send the notification to the users after publish.
     *
     * @param Result $result
     *
     * @return void
     */
    public function publish(Result $result)
    {
        return Notification::send($result->user, new ResultNotifyer($result, 'publish'));;
    }

    /**
     * Send the notification to the users after archive.
     *
     * @param Result $result
     *
     * @return void
     */
    public function archive(Result $result)
    {
        return Notification::send($result->user, new ResultNotifyer($result, 'archive'));;

    }

    /**
     * Send the notification to the users after unpublish.
     *
     * @param Result $result
     *
     * @return void
     */
    public function unpublish(Result $result)
    {
        return Notification::send($result->user, new ResultNotifyer($result, 'unpublish'));;

    }
}
